#include <stdio.h>
#include <ctype.h>

#define M 8
/*e1 */
char chessboard[M][M];



char convert(char c, int upper){
  return upper ? c: tolower(c);
}
void add(char piece, char * sour){
  int i,j;
  i = sour[0] - 'a';
  j = sour[1] - '1';
  chessboard[i][j] = piece;
}
void read_rest(int upper){
  char buffer[3];
  buffer[2]=',';
  char first, piece;
  while (buffer[2]==',') {
    first=getchar();
    if (first>'A' && first<'Z'){
      piece=convert(first, upper);
      fgets(buffer,4,stdin);
    }
    else{
      piece = convert('P',upper);
      buffer[0] = first;
      fgets(buffer+1,3,stdin);
    }

    add(piece, buffer);
  }
}

void print_matrix() {
  int i,j;
  for(j=M-1;j>-1;j--) {
    printf("+---+---+---+---+---+---+---+---+\n");
    for(i=0;i<M;i++) {
      if( (i+j) & 1) {
	if(chessboard[i][j]==0)
	  chessboard[i][j]='.';
	printf("|.%c.",chessboard[i][j]);
      }
      else {
	if(chessboard[i][j]==0)
	  chessboard[i][j]=':';
      	printf("|:%c:",chessboard[i][j]);
      }
    }
    printf("|\n");
 } 
  printf("+---+---+---+---+---+---+---+---+\n");
}


int main(void){
  char buffer[41];
  int white = 1,i,j;
  for(i=0; i<2; i++){
    fgets(buffer,8,stdin);
    read_rest(white);
    white = 0;
  }
  /*  for(i=0;i<M;i++){
    for(j=0;j<M;j++){
      printf("%d",chessboard[i][j]);
    }
    puts("");
    }*/
  print_matrix();
  return 0;
}
