#include <stdio.h>
#include <stdlib.h>
#include <math.h>

long double pi;

int lines, segments;

int lastgood;

struct segment {
	int len,ang;
	double x,y;
};

struct segment *jerab;

void otoc(int co, int okolik) {
	double dx, dy, dd;
	int i;	
	jerab[co].ang=-jerab[co-1].ang+okolik;	
	if (lastgood<co) {
		for (i=lastgood; i<segments+1; i++) {
			jerab[i].x=jerab[i-1].x+jerab[i].len*cos(jerab[i].ang);
			jerab[i].y=jerab[i-1].y+jerab[i].len*sin(jerab[i].ang);
		}
		lastgood=segments;
	}
	else {
		dx=jerab[segments].x-jerab[co].x;
		dy=jerab[segments].y-jerab[co].y;
		dd=dx*dx+dy*dy;		
		jerab[segments].x=jerab[co].x+cos(okolik)*sqrt(dd);
		jerab[segments].y=jerab[co].y+sin(okolik)*sqrt(dd);
		lastgood=co;
	}
}

int main(void) {
	pi=2*acosl(0);
	int i, co, okolik, j;
	while(scanf("%d %d", &segments, &lines)!=EOF){ 
	jerab=(struct segment*)malloc(sizeof(struct segment)*segments+1);
	jerab[0].x=0;
	jerab[0].y=0;
	jerab[0].ang=pi/2;
	jerab[0].len=0;
	for(i=1; i<segments+1; i++) {
		scanf("%d", &jerab[i].len);
		jerab[i].x=0;
		jerab[i].ang=pi/2;
		jerab[i].y=jerab[i-1].y+jerab[i].len;
	}
	lastgood=segments;

	for(i=0; i<lines; i++) {
		scanf("%d %d", &co, &okolik);
		otoc(co,pi*(okolik)/180);
		printf("%.2lf %.2lf\n",jerab[segments].x, jerab[segments].y);
	}
	}
	return 0;
}
